// Sokoban levels based on those in the Nethack game
// (http://www.nethack.org).

var sokobanLevels = [
  {field: ["######  ##### ",
           "#    #  #   # ",
           "# 0  #### 0 # ",
           "# 0 @    0  # ",
           "#  #######0 # ",
           "####   ### ###",
           "       #     #",
           "       #0    #",
           "       # 0   #",
           "      ## 0   #",
           "      #*0 0  #",
           "      ########"],
   boulders: 10},
  
  {field: ["###########   ",
           "#    #    #   ",
           "#  00#00 @#   ",
           "#     0   #   ",
           "#    #    #   ",
           "## #########  ",
           "#  0 #     #  ",
           "# 00 #0 0 0#  ",
           "#  0     0 #  ",
           "# 000#0  0 ###",
           "#    #  0 0 *#",
           "##############"],
   boulders: 20},
                                         
  {field: ["##########    ",
           "#@      *#    ",
           "#       ##    ",
           "####### ######",
           " #           #",
           " # 0 0 0 0 0 #",
           "######## #####",
           "#   0 0  0 0 #",
           "#   0        #",
           "##### ########",
           " #  0 0 0   # ",
           " #     0    # ",
           " # 0 0   0 ## ",
           "####### ####  ",
           "#  0     #    ",
           "#        #    ",
           "#   ######    ",
           "#####         "],
   boulders: 16},

  {field: [" ####         ",
           "## @########  ",
           "#          #  ",
           "# 0#####0# #  ",
           "#  #   # 0 #  ",
           "# 0 0    0##  ",
           "# 0  0  #  #  ",
           "# ####0 ## #  ",
           "#  0   0 # ## ",
           "# ###0#   0 ##",
           "#   #  0# 0 *#",
           "#  0      ####",
           "#####  #  #   ",
           "    #######   "],
   boulders: 12},

  {field: ["######    #####",
           "#  #*##  ##   #",
           "#     #### 0  #",
           "# 00  #  #  0 #",
           "##  00#   00 ##",
           " #0  0   #0  # ",
           " # 00 #  #  0# ",
           " # 0 0#### 0 # ",
           " #       #  ## ",
           " #### 0  # ##  ",
           "    ### ## #   ",
           "     # 0   #   ",
           "     #@ #  #   ",
           "     #######   "],
   boulders: 18}];

function Point(x, y) {
  this.x = x;
  this.y = y;
}
Point.prototype.add = function(other) {
  return new Point(this.x + other.x, this.y + other.y);
};
Point.prototype.isEqualTo = function(other) {
  return this.x == other.x && this.y == other.y;
};
